%{
/* 
  PURPOSE:    DDL 2.1 compliant CIF file lexer ...
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "DDLScannerInt.h"
#include "DDLParser.h"

/*
#undef  YY_DECL
#define YY_DECL int DDLParser::yylex()
#undef   DDL_FLEX_LEXER_INCLUDED
#define  DDL_FLEX_LEXER_INCLUDED
#include "DDLParser.h"
#include "DDLScanner.h"

*/
%}

/* %option noyywrap c++ yyclass="DDLScanner" prefix="DDL" */

%%

^;[^\n]*[\n] {
    int ret;

    ret = ProcessNoneFromDDLScanner();
    if (ret == LSITEMVALUE_DDL)
        return ret;
       }



[\t \n]+      {                                    /* white space */ 
    ProcessWhiteSpaceFromDDLScanner();
    }

[Dd][Aa][Tt][Aa][_][^\n\t ]*   {                 /* data_ */ 
    int ret;

    ret = ProcessDataFromDDLScanner();
    if (ret == DATABLOCK_DDL)
        return ret;
    }


[Ss][Aa][Vv][Ee][_][_][^\n\t ]+ {             /*Item save frame begins */
    int ret;

    ret = ProcessItemSaveBeginFromDDLScanner();
    if (ret == SAVE_BEGIN_DDL)
        return ret;
   }


[Ss][Aa][Vv][Ee][_][^\n\t ]+ {             /* Category save frame begins */
    int ret;

    ret = ProcessCategorySaveBeginFromDDLScanner();
    if (ret == SAVE_BEGIN_DDL)
        return ret;
    }

[Ss][Aa][Vv][Ee][_]  {                /*Save frame ends */
    int ret;

    ret = ProcessSaveEndFromDDLScanner();
    if (ret == SAVE_END_DDL)
        return ret;
   }


[Ll][Oo][Oo][Pp][_]      {                        /* loop_ */
    int ret;

    ret = ProcessLoopFromDDLScanner();
    if (ret == LOOP_DDL)
        return ret;
    }

[Ss][Tt][Oo][Pp][_]      {                        /* stop_ */
    ProcessStopFromDDLScanner();
    }

[.]  {                                        /* Unknown */
    int ret;

    ret = ProcessDotFromDDLScanner();
    if (ret == UNKNOWN_DDL)
        return ret;
     }

[?]  {                                        /* Missing */
    int ret;

    ret = ProcessQuestionFromDDLScanner();
    if (ret == MISSING_DDL)
        return ret;
    }

[#][^\n]*   {                             /* COMMENT */
    ProcessCommentFromDDLScanner();
    }

[_][^\n \t]+  {                /* Item names start with _ end with spaces*/
    int ret;

    ret = ProcessItemNameFromDDLScanner();
    if (ret == ITEMNAME_DDL)
        return ret;
   }

[^\n \t]+   {  /* unquoted or mixed quote strings strings */
    int ret;

    ret = ProcessUnquotedStringFromDDLScanner();
    if (ret == ITEMVALUE_DDL)
        return ret;
   }

[\'](.)*[\'][ \t\n]  { /*  Single Quoted Strings */
    int ret;

    ret = ProcessSQuotedStringFromDDLScanner();
    if (ret == ITEMVALUE_DDL)
        return ret;
   }


[\"](.)*[\"][ \t\n]        {  /* Double Quoted Strings */
    int ret;

    ret = ProcessDQuotedStringFromDDLScanner();
    if (ret == ITEMVALUE_DDL)
        return ret;
   }


<<EOF>> {
    return (ProcessEofFromDDLScanner());
}

%%

void ddl_yy_less(int i)
{
    yyless(i);
}

int yywrap(void)
{
    return (1);
}
