/* a program to convert a structure factor file from mmCIF to CNS format */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include "sf_convert.h"
#include "util.h"

extern char  *CGI_PATH, *URL_USERS_DATA, *USERS_DATA, EXECUTE[512];
extern int DATA_SET;


void get_cns_data_items(char *inpfile, int *nitem, char **items);
void get_cns_labels(FILE *fout, char **items,  int nitem,  const char *fname);
void replace_char(char *str, char find);
void cns_label(const char *name, int i, char *label);
void write_cns_data_4_html(FILE *fout, char **items, int nitem, int i);

    
void get_cns_html(char *inpfile, char *path, char *pdb_id_inp)
{
    char  outfile[512], file_new[256], **items;
    int nitem=0, i;
    FILE  *fout;

   
    strcpy(outfile,"cns_man_convert.html");
    if((fout=fopen(outfile, "w"))==NULL){
        printf("Error, no written permission for file cns_man_convert.html!\n");
        exit(0);
    }
    
    items = set_memory_2d(80,50);
    
    get_cns_data_items(inpfile, &nitem, items);
    
        
    fprintf(fout, "<HTML> \n <Head>\n <TITLE>Manual convert CNS to mmCIF format</TITLE>\n </Head>\n");
    fprintf(fout, "<br> <CENTER> <h2> Semi-auto convertion of CNS to mmCIF format</h2></CENTER>\n");
    fprintf(fout, "\n");
    
    fprintf(fout, "<form ENCTYPE=\"multipart/form-data\" Method=\"post\" Action=\"%s/cns_man_convert.cgi\">\n",CGI_PATH);
    fprintf(fout, "Please select proper item in each entry. Select 'Unassigned', if no item corresponds to the entry. Click RUN to convert CNS to mmCIF format.<p>\n");

//    
//    fprintf(fout, "<tr><td colspan=3 bgcolor=\"khaki\"><font size=4 color=\"#000000\"> <center><b>\n");
//    fprintf(fout, "Number of data set  <INPUT TYPE=TEXT NAME=\"data_set\" SIZE=2 VALUE=%d > </b></center></td></tr> \n",DATA_SET );
    

    for(i=0; i<DATA_SET; i++){
        write_cns_data_4_html(fout, items, nitem,i);
    }
        

//    printf ("command=%s::\n", command);

    
    fprintf(fout, "<INPUT TYPE=SUBMIT NAME=\"submit\" VALUE=\"RUN\"> \n");
    fprintf(fout, "<INPUT TYPE=RESET VALUE= \"RESET\">\n");
    fprintf(fout, "</center><p>\n");
    fprintf(fout, "\n");

    if(strstr(inpfile, "dir_")){ // rid of path
        strcpy(file_new, strstr(inpfile, "dir_")+4);
        if(strchr(file_new, '/')){
            strcpy(file_new, strchr(file_new, '/')+1);
        }    
    }
    
    fprintf(fout, "<input type=\"hidden\"  name=\"pdb_id\" value=\"%s\"> \n", pdb_id_inp);
    fprintf(fout, "<input type=\"hidden\"  name=\"infile\" value=\"%s\"> \n", file_new);
    fprintf(fout, "<input type=\"hidden\"  name=\"user_dir\" value=\"%s\"> \n", path);
    fprintf(fout, "<input type=\"hidden\"  name=\"url_users_data\" value=\"%s\"> \n",URL_USERS_DATA);
    fprintf(fout, "<input type=\"hidden\"  name=\"users_data\" value=\"%s\"> \n",USERS_DATA);
    fprintf(fout, "<input type=\"hidden\"  name=\"sf_convert\" value=\"%s\"> \n",EXECUTE);
    fprintf(fout, "<input type=\"hidden\"  name=\"data_set\" value=\"%d\"> \n",DATA_SET);
    
    fprintf(fout, "\n");
    fprintf(fout, "</BODY> </HTML>\n");
                                                                                
    if(nitem>0) free_memory_2d(items, nitem);
    fclose(fout);
    
    
}
void cns_label(const char *name, int i, char *label)
{
    char tmp[10];
    
    strcpy(label, name);
    if(DATA_SET >= 1){
        sprintf(tmp,"_%d", i+1);
        strcat(label,tmp);
    }
}


void write_cns_data_4_html(FILE *fout, char **items, int nitem, int i)
{
    char label[80];

    
    fprintf(fout, "<center>\n <table cellpadding=8 bgcolor=\"lightblue\">\n");
    
    fprintf(fout, "<font color=\"blue\"><b>Data set %d </b> </font>\n", i+1);
    

// Fp and SigmaFP     
    fprintf(fout, "<tr>\n");
    fprintf(fout, "<td align=center><b>Native data amplitude (Fobs): &nbsp &nbsp <b></td>\n");
    cns_label("FOBS", i, label);
    get_cns_labels(fout,items, nitem, label);

    fprintf(fout, "<td align=center><b>Sigma (SIGMA):  <b></td>\n");    
    cns_label("SIGMA", i, label);
    get_cns_labels(fout,items, nitem, label);
    fprintf(fout, " </tr>\n");

//   Mean intensity sigma(IMEAN).
    fprintf(fout, "<tr>\n");
    fprintf(fout, "<td align=center><b>Mean intensity (Iobs):  <b></td>\n");
    
    cns_label("IOBS", i, label);
    get_cns_labels(fout,items, nitem, label);

    fprintf(fout, "<td align=center><b>Sigma (SIGI): <b></td>\n");    
    cns_label("SIGI", i, label);
    get_cns_labels(fout,items, nitem, label);
    fprintf(fout, " </tr>\n");
        

// FreeR test    
    fprintf(fout, "<tr>\n");
    fprintf(fout, "<td align=center><b> Free R flag (TEST):  <b></td>\n");    
    cns_label("TEST", i, label);
    get_cns_labels(fout,items, nitem, label);
    fprintf(fout, " </tr>\n");

//  Averaged phase (PHIM)
    fprintf(fout, "<tr>\n");
    fprintf(fout, "<td align=center><b>Averaged phase (PHIB): <b></td>\n");  
    cns_label("PHIB", i, label);
    get_cns_labels(fout,items, nitem, label);
    fprintf(fout, " </tr>\n");

//  figure of merit  (FOM)
    fprintf(fout, "<tr>\n");
    fprintf(fout, "<td align=center><b>Figure of merit  (FOM):  <b></td>\n");  
    cns_label("FOM", i, label);
    get_cns_labels(fout,items, nitem, label);
    fprintf(fout, " </tr>\n");


//  Calculated F (FC).Calculated Phase (PHIC)
    fprintf(fout, "<tr>\n");
    fprintf(fout, "<td align=center><b>Calculated F (FC):  <b></td>\n");    
    cns_label("FC", i, label);
    get_cns_labels(fout,items, nitem, label);
    fprintf(fout, "<td align=center><b>Calculated Phase (PHIC):  <b></td>\n");
    cns_label("PHIC", i, label);
    get_cns_labels(fout,items, nitem, label);
    fprintf(fout, " </tr>\n");



//  ABCD H/L coefficients (HLA,HLB,HLC,HLD)
    fprintf(fout, "<tr>\n");
    fprintf(fout, "<td align=center><b>H/L coefficients (HLA):  <b></td>\n");
    cns_label("HLA", i, label);
    get_cns_labels(fout,items, nitem, label);
    
    fprintf(fout, "<td align=center><b>H/L coefficients (HLB):  <b></td>\n");
    cns_label("HLB", i, label);
    get_cns_labels(fout,items, nitem, label);
    fprintf(fout, " </tr>\n");

    fprintf(fout, "<tr>\n");
    fprintf(fout, "<td align=center><b>H/L coefficients (HLC):  <b></td>\n");
    cns_label("HLC", i, label);
    get_cns_labels(fout,items, nitem, label);
    
    fprintf(fout, "<td align=center><b>H/L coefficients (HLD):  <b></td>\n");
    cns_label("HLD", i, label);
    get_cns_labels(fout,items, nitem, label);
    fprintf(fout, " </tr>\n");
    fprintf(fout, "</table>\n");
}

    
void get_cns_data_items(char *inpfile, int *nitem, char **items)
// get data items from CNS
{
    char str[1000], tmp[80], **token=NULL ;
    int i, n,  nref=0, nitems=0;
    FILE *finp, *ftmp;
   
    if((finp=fopen(inpfile,"r"))==NULL){
        open_file_error(inpfile,"get_cns_html");
    }

    
    ftmp = tmpfile();
    
    while (fgets(str, sizeof str, finp) != NULL) {
        sscanf(str,"%s",tmp);
            
        if(strstr_case(tmp, "INDE")){
            fprintf(ftmp, "\n");
            nref++;
        }
        n=strlen(str);
        for(i=0; i<n; i++){
            if(isspace(str[i])) str[i]=' '; 
            fprintf(ftmp, "%c", str[i]);
        }
    }
    
    if(nref < 10  ){
        printf("There are too few reflections in the file (%s).\n", inpfile);
        return;
    }

    rewind(ftmp);
    while (fgets(str, sizeof str, ftmp) != NULL) { 
        if(strstr_case(str,"INDE")){
            token = string_token(str," ", &nitems);
            break;
        }
    }
    for(i=0; i<nitems; i++){
        strcpy( items[i], token[i]);
    }
    
    *nitem=nitems;
    fclose(ftmp);
    fclose(finp);
    if(nitems>0) free_memory_2d(token,nitems);
}


void get_cns_labels(FILE *fout, char **items,  int nitem,  const char *fname)
/* 
only H, K, L, FP, SIGFP, Imean, sigImean, FC, PHIC, PHIB, FOM,  FREE 
are accepted.
*/
    
{
    int  i=0, n;
    char tmp[80], name[80];
    
    fprintf(fout, "<td><SELECT NAME=\"%s\" WIDTH=10>\n", fname);
//strcpy(name, strrchr(fname,'_')+1);
    for(i=0; i<nitem; i++){
        n=strlen(fname);
	strncpy(name,fname, n-2);
	name[n-2]='\0';
        if(strstr_case(items[i], name)) {
            strcpy(tmp,items[i]);
            rid_of_char(tmp, '=');
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n",tmp,tmp);
            break;
        }
    }
        
    fprintf(fout, "<OPTION VALUE=\"\">Unassigned\n");
    for (i=3; i<nitem; i++){
        if(strstr(items[i], "=")){
            strcpy(tmp,items[i]);
            rid_of_char(tmp, '=');
            fprintf(fout, "<OPTION VALUE=\"%s\">%s\n",tmp,tmp);
            
        }
        
    }
    
    fprintf(fout, "</SELECT> </td>\n");
    
    
}

void replace_char(char *str, char find)
/* replace the find by replace in the string str*/
{
    int i, n=0, len;

    len =strlen(str);

    if(!strchr(str,find)){
        printf("Sorry, the character (%c) is not in the string.\n(%s)\n", find ,str);
        return;
    }
    
    for(i = 0; i <len ; i++){
        if(str[i] == find ) continue;
        str[n] = str[i];
        n++;
    }
    
}
